#include "main.h"
#include "Vehicle.h"
#include "Command.h"


WaitCommand * WaitCommand::create(int time)
{
    return new WaitCommand(time);
}

void WaitCommand::apply(Vehicle *vehicle)
{
    vehicle->wait(mTime);
}


ForwardCommand * ForwardCommand::create()
{
    return new ForwardCommand();
}

void ForwardCommand::apply(Vehicle *vehicle)
{
    vehicle->forward();
}


ReleaseCommand * ReleaseCommand::create()
{
    return new ReleaseCommand();
}

void ReleaseCommand::apply(Vehicle *vehicle)
{
    vehicle->release();
}


ReverseCommand * ReverseCommand::create()
{
    return new ReverseCommand();
}

void ReverseCommand::apply(Vehicle *vehicle)
{
    vehicle->reverse();
}


BrakeCommand * BrakeCommand::create()
{
    return new BrakeCommand();
}

void BrakeCommand::apply(Vehicle *vehicle)
{
    vehicle->brake();
}


LeftCommand * LeftCommand::create()
{
    return new LeftCommand();
}

void LeftCommand::apply(Vehicle *vehicle)
{
    vehicle->left();
}


StraightCommand * StraightCommand::create()
{
    return new StraightCommand();
}

void StraightCommand::apply(Vehicle *vehicle)
{
    vehicle->straight();
}


RightCommand * RightCommand::create()
{
    return new RightCommand();
}

void RightCommand::apply(Vehicle *vehicle)
{
    vehicle->right();
}
