#ifndef COMMAND_H_INCL
#define COMMAND_H_INCL


class Vehicle;


class Command
{
public:

    virtual void apply(Vehicle *vehicle) = 0;

protected:

    Command() {}
};


class WaitCommand : public Command
{
public:
    static WaitCommand * create(INT32 time);
    void apply(Vehicle *vehicle);
private:
    WaitCommand(INT32 time) : mTime(time) {}
    INT32 mTime;
};

class ForwardCommand : public Command
{
public:
    static ForwardCommand * create();
    void apply(Vehicle *vehicle);
private:
    ForwardCommand() {}
};

class ReleaseCommand : public Command
{
public:
    static ReleaseCommand * create();
    void apply(Vehicle *vehicle);
private:
    ReleaseCommand() {}
};

class ReverseCommand : public Command
{
public:
    static ReverseCommand * create();
    void apply(Vehicle *vehicle);
private:
    ReverseCommand() {}
};

class BrakeCommand : public Command
{
public:
    static BrakeCommand * create();
    void apply(Vehicle *vehicle);
private:
    BrakeCommand() {}
};

class LeftCommand : public Command
{
public:
    static LeftCommand * create();
    void apply(Vehicle *vehicle);
private:
    LeftCommand() {}
};

class StraightCommand : public Command
{
public:
    static StraightCommand * create();
    void apply(Vehicle *vehicle);
private:
    StraightCommand() {}
};

class RightCommand : public Command
{
public:
    static RightCommand * create();
    void apply(Vehicle *vehicle);
private:
    RightCommand() {}
};


#endif // !COMMAND_H_INCL
