#ifndef GAMESTATE_H_INCL
#define GAMESTATE_H_INCL


#include "State.h"


#define GAME_FPS    100


class Command;
class Font;


class GameState : public State
{
public:

    GameState(char *filename) :
        mLevelNum(1), mFilename(filename) { mFPS = GAME_FPS; }

    void setLevelNumber(INT levelNumber);
    void reset(UINT32 tick);

    INT update(UINT32 tick, KeyEventList &keyEvents);
    void render(SDL_Surface *screen);
    void drawTime();
    void drawLogo();
    void drawLevelInfo();
    void drawStatus();

    virtual void onActivate(UINT32 tick);
    virtual void onDeactivate();

private:

    INT mLevelNum;
    char *mFilename;
    Vehicle mVehicle;
    Level mLevel;
    Font *mFont;
    UINT32 mStartTick, mTick;

};


#endif // !GAMESTATE_H_INCL
