#ifndef LEVEL_H_INCL
#define LEVEL_H_INCL


// don't change order of these, mask colors are mapped for this order
enum LEVEL_MASK_UNIT
{
    LMU_ROAD            = 0,    // 000
    LMU_STARTPOINT      = 1,    // 001
    LMU_CHECKPOINT1     = 2,    // 010
    LMU_CHECKPOINT2     = 3,    // 011
    LMU_GOAL            = 4,    // 100
    LMU_STARTDIRECTION  = 5,    // 101
    LMU_CHECKPOINT3     = 6,    // 110
    LMU_WALL            = 7,    // 111
};


class Vehicle;


class Level
{
public:

    Level();
    ~Level();

    void load(INT levelNumber);

    void update(UINT32 tick);
    void render();

    void hitDetect(Vehicle *vehicle);

    FLOAT getStartX() { return mStartX; }
    FLOAT getStartY() { return mStartY; }
    FLOAT getStartAngle() { return mStartAngle; }
    INT getCheckpoints() { return mCheckpoints; }

private:

    FLOAT mStartX, mStartY, mStartDirX, mStartDirY, mStartAngle;

    IMAGE mImage;
    UINT8 *mMask;
    INT mCheckpoints;
    INT mWidth, mHeight;

};


#endif // !LEVEL_H_INCL
