#ifndef GFX_H_INCL
#define GFX_H_INCL


typedef struct
{
    GLuint glid;
    GLfloat uv[4];
    int w, h;
} IMAGE;


extern void enter2DMode(INT viewportWidth, INT viewportHeight);
extern void leave2DMode();

extern GLuint SDL_GL_LoadTexture(SDL_Surface *surface, GLfloat *texcoord,
                                 SDL_Rect *srcrect = NULL);
extern IMAGE loadImage(char *filename);
extern void freeImage(const IMAGE &image);

extern void drawImage(const IMAGE &img, FLOAT x = 0, FLOAT y = 0,
                      FLOAT r = 1, FLOAT g = 1,
                      FLOAT b = 1, FLOAT a = 1);
extern void drawImageRotatedCentered(const IMAGE &img,
                                     FLOAT x = 0, FLOAT y = 0, FLOAT angle = 0,
                                     FLOAT r = 1, FLOAT g = 1,
                                     FLOAT b = 1, FLOAT a = 1);
extern void drawImageAdditive(const IMAGE &img,
                              FLOAT x = 0, FLOAT y = 0, FLOAT angle = 0,
                              FLOAT r = 1, FLOAT g = 1,
                              FLOAT b = 1, FLOAT a = 1);


#endif // !GFX_H_INCL